import random, sys
try:
   import tkinter  # Python 3
   from tkinter import messagebox
except:
   import Tkinter as tkinter # Python 2
   import tkMessageBox as messagebox

TREFFER = 9
MAXSCHIFF = 4
MAXX = 9
MAXY = 7
NORD = 1
NORDWEST = 2
WEST = 3
SUEDWEST = 4
SUED = 5
SUEDOST = 6
OST = 7
NORDOST = 8
HIMMELSRICHTUNGEN = 8

class Koordinate:
    def __init__(self):
        self.x = 0
        self.y = 0

    def __eq__(self, koord):
        return self.x==koord.x and self.y==koord.y

    def __ne__(self, koord):
        return self.x!=koord.x or self.y!=koord.y

    def __str__(self):
        return "{}, {}".format(self.x, self.y)

class Schiff:
    def __init__(self):
        self.pos = Koordinate()
        self.neusetzen()
        self.gefunden = False

    def neusetzen(self):
        self.pos.x = random.randint(0, MAXX-1)
        self.pos.y = random.randint(0, MAXY-1)

    def peile(self, x, y):
        print("Schiff.peile", x, y)
        # Ist dieses Schiff getroffen?
        if x==self.pos.x and y==self.pos.y:
            self.gefunden = True
            return TREFFER
        if x==self.pos.x:
            if y<self.pos.y:
                return OST
            else:
                return WEST
        if y==self.pos.y:
            if x<self.pos.x:
                return NORD
            else:
                return SUED
        if x-self.pos.x == y-self.pos.y:
            if x<self.pos.x:
                return SUEDWEST
            else:
                return NORDOST
        if x-self.pos.x == (y-self.pos.y)*-1:
            if x<self.pos.x:
                return NORDWEST
            else:
                return SUEDOST
        return 0

class FeldElement:
    def __init__(self, x, y):
        self.x = x
        self.y = y
        self.button = tkinter.Button(spielframe,
                text=chr(x+ord('A'))+chr(y+ord('1')),
                command=self.klick,
                disabledforeground="red"
                )
        self.button.grid(column=x, row=y)

    def klick(self):
        peilungen=spiel.peile(self.x, self.y)
        self.button.configure(state=tkinter.DISABLED)
        if peilungen >= TREFFER: # Schiff gefunden
            self.button["text"] = "W"
            if spiel.alleSchiffeGefunden():
                messagebox.showinfo("Super!", "Alle Schiffe gefunden!")
                sys.exit(0) # Ende des Programms
        else:
            self.button["text"] = chr(peilungen + ord('0'))

class Spiel:
    def __init__(self):
        # fuer die Textdarstellung wurde dies benötigt
        #self.spielfeld = [['+' for y in range(MAXY)] for x in range(MAXX)]
        # fuer tkinter-Kontrollelemente-Version
        self.element = [[FeldElement(x, y)
                for y in range(MAXY)] for x in range(MAXX)]
        self.schiffe = []
        for i in range(MAXSCHIFF):
            self.schiffe.append(Schiff())
        self.doppelSchiffCheck()
        for i in range(MAXSCHIFF):# zum Debuggen:
            print(self.schiffe[i].pos) # zeig Schiffspositionen

    # zeigFeld wird in der grafischen Umgebung nicht gebraucht
    #def zeigFeld(self):
    #    print("   A B C D E F G H I")
    #    for y in range(MAXY):
    #        print(chr(ord('1')+y), end="  ")
    #        for x in range(MAXX):
    #            print(self.spielfeld[x][y], end=" ")
    #        print("")

    def doppelSchiffCheck(self):
        testSchiff = 0
        while testSchiff < MAXSCHIFF:
            vorSchiff = 0
            while vorSchiff < testSchiff:
                # print(i, testSchiff) # Zeigt die verglichenen Schiffe
                if self.schiffe[vorSchiff].pos \
                        == self.schiffe[testSchiff].pos:
                    self.schiffe[testSchiff].neusetzen()
                    testSchiff -= 1 # dieses Schiff erneut testen
                    vorSchiff = -1 # alle bisherigen Schiffe vergleichen
                vorSchiff += 1
            testSchiff += 1

    def alleSchiffeGefunden(self):
        for schiff in self.schiffe:
            if not(schiff.gefunden):
                return False
        return True

    def peile(self, x, y):
        richtungen = [0 for x in range(HIMMELSRICHTUNGEN)]
        for schiff in self.schiffe:
            richtung = schiff.peile(x, y)
            if richtung == TREFFER:
                return TREFFER
            if richtung>0:
                richtungen[richtung-1] = 1
        return sum(richtungen)

# Die Fensterumgebunt muss vor dem Spiel initialisiert werden,
# weil das Spiel die Buttons anlegen muss
fenster = tkinter.Tk()
spielframe = tkinter.Frame(fenster)
spielframe.pack()
spiel = Spiel()
fenster.mainloop()


