import Tkinter as tk

class LabelTabelle(tk.Frame):
    def __init__(self, eltern, rows=10, columns=2, bgcol="black"):
        tk.Frame.__init__(self, eltern, background=bgcol)
        self.__rows = rows
        self.__cols = columns
        self.__widgets = []
        for row in range(rows):
            current_row = []
            for column in range(columns):
                label = tk.Label(self,
                        #text="%s/%s" % (row, column), 
                        borderwidth=0, width=10)
                label.grid(row=row, column=column,
                        sticky="nsew", padx=1, pady=1)
                current_row.append(label)
            self.__widgets.append(current_row)

        for column in range(columns):
            self.grid_columnconfigure(column, weight=1)

    def setZelle(self, row, column, value):
        if row>=self.__rows or column>=self.__cols:
            return
        widget = self.__widgets[row][column]
        widget.configure(text=value)
        if type(value) in (int, long, float):
            widget.configure(anchor=tk.E)
        else:
            widget.configure(anchor=tk.W)

    def setZeile(self, row, liste):
        col = 0
        for element in liste:
            self.setZelle(row, col, element)
            col += 1

    def setSpaltenbreite(self, col, breite):
         for row in range(self.__rows):
             self.__widgets[row][col].configure(width=breite)

if __name__ == "__main__":
    fenster = tk.Tk()
    zeilen = 7
    spalten = 4
    tab = LabelTabelle(fenster, rows=zeilen, columns=spalten)
    tab.pack(side="top", fill="x")
    for i in range(zeilen):
        for j in range(spalten):
           tab.setZelle(row=i, column=j, value=(i+1)*(j+1))
    tab.setZelle(2, 1, "Netter")
    tab.setZelle(4, 2, "Tabelleninhalt")
    tab.setZeile(3, ("Aston", "BMW", "Citroen", "Dacia", "Error"))
    tab.setSpaltenbreite(2, 20)
    fenster.mainloop()

