import random, sys
try:
   import tkinter  # Python 3
   from tkinter import messagebox
except:
   import Tkinter as tkinter # Python 2
   import tkMessageBox as messagebox

TREFFER = 9
MAXSCHIFF = 4
MAXX = 9
MAXY = 7
NORD = 1
NORDWEST = 2
WEST = 3
SUEDWEST = 4
SUED = 5
SUEDOST = 6
OST = 7
NORDOST = 8
HIMMELSRICHTUNGEN = 8

HEIGHT = 32
WIDTH  = 32

class Koordinate:
    def __init__(self):
        self.x = 0
        self.y = 0

    def __eq__(self, koord):
        return self.x==koord.x and self.y==koord.y

    def __ne__(self, koord):
        return self.x!=koord.x or self.y!=koord.y

    def __str__(self):
        return "{}, {}".format(self.x, self.y)

class Schiff:
    def __init__(self):
        self.pos = Koordinate()
        self.neusetzen()
        self.gefunden = False

    def neusetzen(self):
        self.pos.x = random.randint(0, MAXX-1)
        self.pos.y = random.randint(0, MAXY-1)

    def peile(self, x, y):
        print("Schiff.peile", x, y)
        # Ist dieses Schiff getroffen?
        if x==self.pos.x and y==self.pos.y:
            self.gefunden = True
            return TREFFER
        if x==self.pos.x:
            if y<self.pos.y:
                return OST
            else:
                return WEST
        if y==self.pos.y:
            if x<self.pos.x:
                return NORD
            else:
                return SUED
        if x-self.pos.x == y-self.pos.y:
            if x<self.pos.x:
                return SUEDWEST
            else:
                return NORDOST
        if x-self.pos.x == (y-self.pos.y)*-1:
            if x<self.pos.x:
                return NORDWEST
            else:
                return SUEDOST
        return 0


class Spiel:
    def __init__(self):
        self.drawLinien()
        self.drawDiagonalen()
        self.schiffe = []
        for i in range(MAXSCHIFF):
            self.schiffe.append(Schiff())
        self.doppelSchiffCheck()
        for i in range(MAXSCHIFF):# zum Debuggen:
            print(self.schiffe[i].pos) # zeig Schiffspositionen

    def drawLinien(self):
        for y in range(0, MAXY):
            for x in range(0, MAXX):
                spielcanvas.create_line(WIDTH/2, y*HEIGHT+(HEIGHT/2),
                        (MAXX-0.5)*WIDTH, y*HEIGHT+(HEIGHT/2))
                spielcanvas.create_line(x*WIDTH+(HEIGHT/2), HEIGHT/2,
                        x*WIDTH+(HEIGHT/2), (MAXY-0.5)*HEIGHT)

    def drawDiagonalen(self):
        anfang = Koordinate() # eigentlich die Position
        ende = Koordinate()   # eigentlich die Position
        for lauf in range(MAXX+MAXY-2):
            # Diagonale von links unten nach rechts oben
            anfang.x = lauf
            anfang.y = 0
            if lauf>=MAXX:
                anfang.x = MAXX - 1
                anfang.y = lauf - MAXX + 1
            ende.x = 0
            ende.y = lauf
            if lauf>=MAXY:
                ende.y = MAXY - 1
                ende.x = lauf - MAXY + 1
            versatz = 0.5
            spielcanvas.create_line(WIDTH*(anfang.x+versatz),
                    HEIGHT*(anfang.y+versatz),
                    WIDTH*(ende.x+versatz),
                    HEIGHT*(ende.y+versatz))
            # Diagonale von links oben nach rechts unten
            anfang.x = 0
            anfang.y = MAXY - lauf - 1
            if anfang.y < 0:
                anfang.x = -anfang.y
                anfang.y = 0
            ende.x = lauf
            ende.y = MAXY - 1
            if lauf>=MAXX:
                ende.y -= lauf - MAXX + 1
                ende.x = MAXX - 1
            spielcanvas.create_line(WIDTH*(anfang.x+versatz),
                    HEIGHT*(anfang.y+versatz),
                    WIDTH*(ende.x+versatz),
                    HEIGHT*(ende.y+versatz))

    def zeichne(self, x, y, symbol):
        # Die Icons funktionieren nicht!
        #img = tkinter.PhotoImage(file="image/marke1.gif")
        #spielcanvas.create_image(0, 0, anchor=tkinter.NW, image=img)
        if symbol=='W':
            spielcanvas.create_oval((x+.25)*WIDTH, (y+.25)*HEIGHT,
                (x+.75)*WIDTH, (y+.75)*HEIGHT, fill="red")
        else:
            spielcanvas.create_rectangle((x+.25)*WIDTH, (y+.25)*HEIGHT,
                    (x+.75)*WIDTH, (y+.75)*HEIGHT, fill="yellow")
            spielcanvas.create_text((x+.5)*WIDTH, (y+.5)*HEIGHT, text=symbol, 
                    anchor=tkinter.CENTER)

    def doppelSchiffCheck(self):
        testSchiff = 0
        while testSchiff < MAXSCHIFF:
            vorSchiff = 0
            while vorSchiff < testSchiff:
                # print(i, testSchiff) # Zeigt die verglichenen Schiffe
                if self.schiffe[vorSchiff].pos \
                        == self.schiffe[testSchiff].pos:
                    self.schiffe[testSchiff].neusetzen()
                    testSchiff -= 1 # dieses Schiff erneut testen
                    vorSchiff = -1 # alle bisherigen Schiffe vergleichen
                vorSchiff += 1
            testSchiff += 1

    def alleSchiffeGefunden(self):
        for schiff in self.schiffe:
            if not(schiff.gefunden):
                return False
        return True

    def peile(self, x, y):
        richtungen = [0 for x in range(HIMMELSRICHTUNGEN)]
        for schiff in self.schiffe:
            richtung = schiff.peile(x, y)
            if richtung == TREFFER:
                return TREFFER
            if richtung>0:
                richtungen[richtung-1] = 1
        return sum(richtungen)

    def fangeKlick(self, event):
        x = (event.x)//WIDTH
        y = (event.y)//HEIGHT
        print("Position", x, y)
        peilungen=self.peile(x, y)
        if peilungen >= TREFFER: # Schiff gefunden
            self.zeichne(x, y, "W")
            if spiel.alleSchiffeGefunden():
                messagebox.showinfo("Super!", "Alle Schiffe gefunden!")
                sys.exit(0) # Ende des Programms
        else:
            self.zeichne(x, y, chr(peilungen + ord('0')))

fenster = tkinter.Tk()
spielcanvas = tkinter.Canvas(fenster, width=9*WIDTH, height=7*HEIGHT)
spielcanvas.pack()
spiel = Spiel()
spielcanvas.bind("<Button-1>", spiel.fangeKlick)
fenster.mainloop()


